package adt.mainnode.dto;

import lombok.Data;
import adt.mainnode.entity.Port;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;

@Data
public class PortDto {

    //private int id;
    @JsonProperty("port")
    private String portNumber;

    @JsonIgnore
    private HostDto hostDto;

    @JsonProperty("service")
    private String serviceRunning;

    @JsonProperty("service_version")
    private String serviceVersion;

    @JsonProperty("protocol")
    private String protocol;

    @JsonProperty("discovery_method")
    private String discoveryMethod;

    @JsonProperty("state")
    private String state;

    public static PortDto createPortDto(Port port) {
        PortDto portDto = new PortDto();
        portDto.setPortNumber(port.getPortNumber());
        portDto.setServiceRunning(port.getServiceRunning());
        portDto.setServiceVersion(port.getServiceVersion());
        portDto.setProtocol(port.getProtocol());
        portDto.setDiscoveryMethod(port.getDiscoveryMethod());
        portDto.setState(port.getState());
        return portDto;
    }

    public static PortDto createPortDto_nlp(String portNumber, String serviceRunning, String serviceVersion, String protocol, String discoveryMethod, String state) {

        PortDto portDto = new PortDto();
        portDto.setPortNumber(portNumber);
        portDto.setServiceRunning(serviceRunning);
        portDto.setServiceVersion(serviceVersion);
        portDto.setProtocol(protocol);
        portDto.setDiscoveryMethod(discoveryMethod);
        portDto.setState(state);
        return portDto;
    }

}
