package adt.mainnode.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import java.util.Date;
import lombok.Data;
import java.util.List;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.time.DateUtils;
import java.text.ParseException;

@Data
@Slf4j
public class ScanInfoDto {

    @JsonProperty("vlan_id")
    String vlanName;

    @JsonProperty("timestamp_main_node")
    Date mainNode_timestamp;

    @JsonProperty("node_ip_address")
    String nodeIp;

    @JsonProperty("timestamp_dist_node_scan_start")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date iniTimestampScan;

    @JsonProperty("timestamp_dist_node_scan_end")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date endTimestampScan;

    @JsonProperty("devices")
    private List<HostDto> host;

    @JsonProperty("mac_address")
    private String macAddress;

    public static ScanInfoDto createScanInfoDto_nlp(String vlanName, Date mainNode_timestamp, String nodeIp,
                                                    String iniTimestampScan, String endTimestampScan, List<HostDto> hostDtos,
                                                    String macAddress) {

        ScanInfoDto scanInfoDto = new ScanInfoDto();

        scanInfoDto.setVlanName(vlanName);
        scanInfoDto.setMainNode_timestamp(mainNode_timestamp);
        scanInfoDto.setNodeIp(nodeIp);

        iniTimestampScan = iniTimestampScan.replace("b", "");
        iniTimestampScan = iniTimestampScan.replace("'", "");
        endTimestampScan = endTimestampScan.replace("b", "");
        endTimestampScan = endTimestampScan.replace("'", "");

        try {

            Date date1 = DateUtils.parseDate(iniTimestampScan, "yyyy-MM-dd HH:mm:ss");

            Date date2 = DateUtils.parseDate(endTimestampScan, "yyyy-MM-dd HH:mm:ss");

            scanInfoDto.setIniTimestampScan(date1);
            scanInfoDto.setEndTimestampScan(date2);
        }catch(ParseException p){
            log.error("{}",p);
        }


        scanInfoDto.setHost(hostDtos);
        scanInfoDto.setMacAddress(macAddress);

        return scanInfoDto;
    }
}
