package adt.mainnode.entity;


import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Transient;
import javax.validation.constraints.Email;
import javax.validation.constraints.NotBlank;
import java.util.ArrayList;
import java.util.List;

@Entity
@Data
@NoArgsConstructor
public class Credentials {

    @Column(name = "type")
    private String type;

    @Column(name = "email")
    private String email;

    @Column(name = "name")
    private String name;

    @Column(name = "description")
    private String description;

    @Column(name = "password")
    private String password;

    @Id
    @Column(name = "token")
    private String token;

    @Column(name = "availableEndpoint")
    private String availableEndpoint;

    @Column(name = "pcr_token")
    private String pcrToken;

    @Column(name = "status")
    private String status;

    @Transient
    private String[] endpoints;

    public static Credentials createCredentials(/*String nodeId, String vlanName,*/ String type, String email, String name, String description, String token, String availableEndpoing) {

        Credentials credentials = new Credentials();

        //credentials.setNodeId(nodeId);
        //credentials.setVlanName(vlanName);
        credentials.setType(type);
        credentials.setEmail(email);
        credentials.setName(name);
        credentials.setDescription(description);
        credentials.setToken(token);
        credentials.setAvailableEndpoint(availableEndpoing);

        return credentials;
    }
}
