package adt.mainnode.entity;

import adt.mainnode.identity.ScanConfigIdentity;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.validation.constraints.NotBlank;

@Entity
@Data
@NoArgsConstructor
@IdClass(ScanConfigIdentity.class)
public class ScanConfig {

    @Id
    @Column(name = "nodeId")
    private String nodeId;

    @Id
    @Column(name = "vlanName")
    private String vlanName;

    @Column(name = "ipToScan")
    private String ipToScan;

    @Column(name = "mask")
    private String mask;

    @Column(name = "delay")
    private Long delay;

    public static ScanConfig createScanConfig(String vlanName, String nodeId,/* String token,*/ String ipToScan, String mask, Long delay) {

        ScanConfig scanConfig = new ScanConfig();

        scanConfig.setNodeId(nodeId);
        scanConfig.setVlanName(vlanName);
        //scanConfig.setToken(token);
        scanConfig.setIpToScan(ipToScan);
        scanConfig.setMask(mask);
        scanConfig.setDelay(delay);

        return scanConfig;
    }

}
