package adt.mainnode.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Transient;
import javax.validation.constraints.Email;
import javax.validation.constraints.NotBlank;
import java.util.ArrayList;
import java.util.List;
import java.util.Date;

@Entity
@Data
@NoArgsConstructor
public class TPMHash {

    @Id
    @Column(name = "hash")
    private String hash;

    @Column(name = "timestamp")
    private Date timestamp;


    public static TPMHash createTPMHash(String hash) {

        TPMHash myHash = new TPMHash();

        myHash.setHash(hash);
        myHash.setTimestamp(new Date());

        return myHash;
    }
}
