package adt.mainnode.entity.changed;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;

import java.text.ParseException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import adt.mainnode.identity.SnapshotIdentity;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.time.DateUtils;

import java.util.Date;

import java.util.List;
import java.util.ArrayList;

import javax.persistence.Transient;

import adt.mainnode.entity.changed.*;

@Entity
@Data
@NoArgsConstructor
public class DeviceChange {

    @Id
    @Column(name = "timestamp_device")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    Date timestamp_device;

    @JsonProperty("type_of_change")
    String type_of_change;

    @JsonProperty("ip_address")
    String ip_address;

    @JsonProperty("mac_address")
    String mac_address;

    @JsonProperty("operating_system")
    String operating_system;

    @Transient
    @JsonProperty("ports")
    List<PortChange> ports;

    public static DeviceChange createDeviceChange(Date timestamp_device, String type_of_change, String ip_address,
                                                  String mac_address, String operating_system, List<PortChange> ports) {

        DeviceChange deviceChange = new DeviceChange();

        deviceChange.setTimestamp_device(timestamp_device);
        deviceChange.setType_of_change(type_of_change);
        deviceChange.setIp_address(ip_address);
        deviceChange.setMac_address(mac_address);
        deviceChange.setOperating_system(operating_system);
        deviceChange.setPorts(ports);

        return deviceChange;
    }


}
