package adt.mainnode.entity.changed;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;

import java.text.ParseException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import adt.mainnode.identity.SnapshotIdentity;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.time.DateUtils;

import java.util.Date;

import java.util.List;
import java.util.ArrayList;

import javax.persistence.Transient;

import adt.mainnode.entity.changed.*;


@Entity
@Data
@NoArgsConstructor
public class SnapshotChange {

    @Id
    @Column(name = "timestamp_snapshot")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    Date timestamp_snapshot;

    @Column(name = "discovery_method")
    String discoveryMethod;

    @Transient
    @JsonProperty("vlans")
    List<VlanChange> vlans;

    public static SnapshotChange createSnapshotChange(Date timestamp_snapshot, List<VlanChange> vlans, String discoveryMethod) {

        SnapshotChange snapshotChange = new SnapshotChange();

        snapshotChange.setTimestamp_snapshot(timestamp_snapshot);
        snapshotChange.setVlans(vlans);
        snapshotChange.setDiscoveryMethod(discoveryMethod);

        return snapshotChange;
    }


}
