package adt.mainnode.entity.changed;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.NoArgsConstructor;
import adt.mainnode.identity.VlanIdentity;

import javax.persistence.*;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Transient;
import java.util.ArrayList;
import java.util.List;

import adt.mainnode.entity.changed.*;

@Entity
@Data
@NoArgsConstructor
public class VlanChange {

    @Id
    @JsonProperty("vlan_id")
    @Column(name = "vlan_id")
    String vlan_id;

    @Transient
    @JsonProperty("devices")
    List<DeviceChange> hosts;

    public static VlanChange createVlanChange(String vlan_id, List<DeviceChange> hosts) {

        VlanChange vlanChange = new VlanChange();

        vlanChange.setVlan_id(vlan_id);
        vlanChange.setHosts(hosts);

        return vlanChange;
    }


}
