package adt.mainnode.identity;

import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Embeddable;
import javax.persistence.Id;
import java.io.Serializable;

@Embeddable
@Data
@NoArgsConstructor
public class HostIdentity implements Serializable {

    @Id
    @Column(name = "ip")
    private String ip;

    @Id
    @Column(name = "vlan_name")
    private String vlanName;

    @Id
    @Column(name = "snapshotId")
    private String snapshotId;

    public static HostIdentity createHostIdentity(String ip, String vlanName, String snapshotId) {
        HostIdentity hostIdentity = new HostIdentity();
        hostIdentity.setIp(ip);
        hostIdentity.setVlanName(vlanName);
        hostIdentity.setSnapshotId(snapshotId);
        return hostIdentity;
    }

}
