package adt.mainnode.identity;

import lombok.*;

import javax.persistence.Column;
import javax.persistence.Embeddable;
import javax.persistence.Id;
import java.io.Serializable;

@Embeddable
@Getter
@Setter(AccessLevel.PRIVATE)
@NoArgsConstructor
public class PortIdentity implements Serializable {

    @Id
    @Column(name = "port_number")
    private String portNumber;

    @Id
    @Column(name = "ip")
    private String ip;

    @Id
    @Column(name = "vlan_name")
    private String vlanName;

    @Id
    @Column(name = "snapshotId")
    private String snapshotId;

    public static PortIdentity createPortIdentity(String portNumber, String ip, String vlanName, String snapshotId) {
        PortIdentity portIdentity = new PortIdentity();
        portIdentity.setPortNumber(portNumber);
        portIdentity.setIp(ip);
        portIdentity.setVlanName(vlanName);
        portIdentity.setSnapshotId(snapshotId);
        return portIdentity;
    }

}
