package adt.mainnode.identity;

import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Embeddable;
import javax.persistence.Id;
import java.io.Serializable;

@Embeddable
@Data
@NoArgsConstructor
public class SnapshotIdentity implements Serializable {

    @Id
    @Column(name = "vlan_name")
    private String vlanName;

    @Id
    @Column(name = "node_id")
    private String nodeId;

    @Id
    @Column(name = "snapshotId")
    private String snapshotId;

    public static SnapshotIdentity createSnapshotIdentity(String vlanName, String nodeId, String snapshotId) {
        SnapshotIdentity snapshotIdentity = new SnapshotIdentity();
        snapshotIdentity.setVlanName(vlanName);
        snapshotIdentity.setNodeId(nodeId);
        snapshotIdentity.setSnapshotId(snapshotId);

        return snapshotIdentity;
    }
}
