package adt.mainnode.identity;

import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Embeddable;
import javax.persistence.Id;
import java.io.Serializable;

@Embeddable
@Data
@NoArgsConstructor
public class VlanIdentity implements Serializable {


    @Id
    @Column(name = "distributedNodeId")
    private String distributedNodeId;

    @Id
    @Column(name = "vlan_name")
    private String vlanName;


    public static VlanIdentity createVlanIdentity(String distributedNodeId, String vlanName) {
        VlanIdentity vlanIdentity = new VlanIdentity();
        vlanIdentity.setDistributedNodeId(distributedNodeId);
        vlanIdentity.setVlanName(vlanName);
        return vlanIdentity;
    }

}
