package adt.mainnode.repository;

import adt.mainnode.entity.ScanConfig;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

public interface ScanConfigRepository extends JpaRepository<ScanConfig, String>{

    ScanConfig findByVlanName(String vlanName);
    ScanConfig findByIpToScan(String ipToScan);
    List<ScanConfig> findAllByNodeId(String nodeId);
    List<ScanConfig> findAllByIpToScan(String ipToScan);

    @Transactional
    void deleteByVlanName(String vlanName);
    @Transactional
    void deleteAllByNodeId(String nodeId);
}