package adt.mainnode.repository;

import adt.mainnode.entity.Snapshot;
import org.springframework.data.jpa.repository.JpaRepository;
import java.util.List;

public interface SnapshotRepository extends JpaRepository<Snapshot, String> {

    List<Snapshot> findAllByVlanName(String vlanName);
    List<Snapshot> findAllByVlanNameAndNodeId(String vlanName, String nodeId);
    Snapshot findBySnapshotId(String snapshotId);

    Snapshot findTopByVlanNameOrderByTimestampDistNodeEndDesc(String vlanName);
    Snapshot findTopByVlanNameAndDiscoveryMethodOrderByTimestampDistNodeEndDesc (String vlanName, String discoveryMethod);

}
