<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="core" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<html lang="en">
<head>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">

  <link href="webjars/bootstrap/4.1.3/css/bootstrap.min.css" rel="stylesheet">

  <style type="text/css">

   fieldset{ position:relative; }
   fieldset.lock::before{
     content:'';
     position:absolute;
     z-index:999;
     top:0;
     right:0;
     bottom:0;
     left:0;
   }

   button.on{ color:red; }

  </style>

<title>Add credentials</title>
</head>
<body>

<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js"></script>
<script src="https://code.jquery.com/ui/1.11.1/jquery-ui.min.js"></script>
<script src="https://code.jquery.com/jquery-1.10.2.js"
	type="text/javascript"></script>
<!-- <script src="ajax/ajax_check.js" type="text/javascript"></script>-->

<link rel="stylesheet" href="https://code.jquery.com/ui/1.11.1/themes/smoothness/jquery-ui.css" />

<c:set id="count" var="count" value="0" scope="page" />

<c:set id="validationType" var="validationType" value="true" scope="page" />

<script language="javascript">

function validateForm(usageFlag)
{

   var flag = true;

   var names = ["formName", "formEmail"];

   var forms = document.forms["myForm"];

   var checks = document.querySelectorAll('[id^="formAvailable"]')

   var valType = document.getElementById("validationType");

   var checkCounter = 0;

    for (var i = 0; i < checks.length; i++) {


            if (checks[i].checked) {

                checkCounter = checkCounter + 1;
            }

    }

    if(checkCounter == 0){

        flag = false;

         document.getElementById("formAvailable_message").style.visibility="visible";
         document.getElementById("formAvailable_message").style.color="crimson";
         document.getElementById("formAvailable_message").innerHTML="At least one option must be selected.";
         //document.getElementById("formAvailable").style.borderColor="red";
    }else{

         document.getElementById("formAvailable_message").style.visibility="";
         document.getElementById("formAvailable_message").innerHTML="";
         //document.getElementById("formAvailable").style.borderColor="";
    }

   names.forEach(function(name) {

     var x = forms[name].value;

     if(x==null || x==""){

             flag = false;

             document.getElementById(name+'_message').style.visibility="visible";
             document.getElementById(name+'_message').style.color="crimson";
             document.getElementById(name+'_message').innerHTML="This field must not be empty.";
             document.getElementById(name).style.borderColor="red";

         }else{
             document.getElementById(name+'_message').style.visibility="";
             document.getElementById(name+'_message').innerHTML="";
             document.getElementById(name).style.borderColor="";

             if(name == "formEmail" &&  ! (/^[^\s@]+@[^\s@]+\.[^\s@]+$/.test(x)) ){

                flag = false;

                 document.getElementById(name+'_message').style.visibility="visible";
                 document.getElementById(name+'_message').style.color="crimson";
                 document.getElementById(name+'_message').innerHTML="The provided email format is not valid.";
                 document.getElementById(name).style.borderColor="red";
             }


         }
   });

    if(!usageFlag || valType.attributes[2].value == "false"){

        return flag;
    }

    var message_table = "";
    var message_vlan = "";
    var message_ip = "";
    var message_mask = "";
    var message_delay = "";

    var wrong_vlan = [];
    var wrong_ip = [];
    var wrong_mask = [];
    var wrong_delay = [];

    var delayFlag = true;

    var delayContent = document.getElementById("generalDelay").value

    if(isNaN(delayContent) || delayContent.length == 0){

        flag = false;
        delayFlag = false;
        message_delay = "Delay should be an integer."

    }


    var elems = document.querySelectorAll("[name^='configs[']");

    elems.forEach(function(elem) {

        x = elem.name.split(".");


        if(x[1].localeCompare("vlanName") == 0){

            content = elem.value

            var idx = x[0].substring(
                x[0].lastIndexOf("[") + 1,
                x[0].lastIndexOf("]")
            );

            if(content.length == 0){

                flag = false;
                message_vlan = "Vlan Name must not be empty. Please check "; // row/rows {}

                wrong_vlan[wrong_vlan.length] = idx;
            }

        }else if(x[1].localeCompare("ipToScan") == 0){

            content = elem.value.split(".");

            var idx = x[0].substring(
                x[0].lastIndexOf("[") + 1,
                x[0].lastIndexOf("]")
            );

            if(content.length != 4){

                flag = false;
                message_ip = "The IP format introduced in "; // row/rows {} is not valid.

                wrong_ip[wrong_ip.length] = idx;
            }

            content.forEach(function(block) {

                if(!(block >= 0 && block <= 255)){

                    flag = false;
                    message_ip = "The provided IP format is not valid. Please check "; // row/rows {} is not valid.

                    if( ! wrong_ip.includes(idx)){

                        wrong_ip[wrong_ip.length] = idx;
                    }

                }

            });

        }else if(x[1].localeCompare("mask") == 0){

            content = elem.value

            var idx = x[0].substring(
                x[0].lastIndexOf("[") + 1,
                x[0].lastIndexOf("]")
            );


            if(!(content >= 8 && content <= 30) || content.length == 0){

                flag = false;
                message_mask = "Mask should be an integer from 8 to 30. Please check "; // row/rows {}.

                if( ! wrong_mask.includes(idx)){

                    wrong_mask[wrong_mask.length] = idx;
                }

            }

        }else if(x[1].localeCompare("delay") == 0){

            elem.value = delayContent;

            /*content = elem.value

            var idx = x[0].substring(
                x[0].lastIndexOf("[") + 1,
                x[0].lastIndexOf("]")
            );


            if(isNaN(content) || content.length == 0){

                flag = false;
                message_delay = "Delay should be an integer. Please check "; // row/rows {}.

                if( ! wrong_delay.includes(idx)){

                    wrong_delay[wrong_delay.length] = idx;
                }

            }*/

        }

    });


    if(wrong_vlan.length > 0){

        //message_table = message_table + message_vlan;
        if(wrong_vlan.length > 1){

            message_vlan = message_vlan + "rows {"+wrong_vlan+"}.";

        }else{

            message_vlan = message_vlan + "row {"+wrong_vlan+"}.";
        }
    }
    if(wrong_ip.length > 0){

        //message_table = message_table + message_ip;
        if(wrong_ip.length > 1){

            message_ip = message_ip + "rows {"+wrong_ip+"}.";

        }else{

            message_ip = message_ip + "row {"+wrong_ip+"}.";
        }
    }
    if(wrong_mask.length > 0){

        //message_table = message_table + message_mask;
        if(wrong_mask.length > 1){

            message_mask = message_mask + "rows {"+wrong_mask+"}.";

        }else{

            message_mask = message_mask + "row {"+wrong_mask+"}.";
        }
    }
    /*if(wrong_delay.length > 0){

        //message_table = message_table + message_delay;
        if(wrong_delay.length > 1){

            message_delay = message_delay + "rows {"+wrong_delay+"}.";

        }else{

            message_delay = message_delay + "row {"+wrong_delay+"}.";
        }
    }*/

    document.getElementById("formVlan_message_vlan").style.visibility = "visible";
    document.getElementById("formVlan_message_vlan").style.color = "crimson";
    document.getElementById("formVlan_message_vlan").innerHTML = message_vlan;

    document.getElementById("formVlan_message_ip").style.visibility = "visible";
    document.getElementById("formVlan_message_ip").style.color = "crimson";
    document.getElementById("formVlan_message_ip").innerHTML = message_ip;

    document.getElementById("formVlan_message_mask").style.visibility = "visible";
    document.getElementById("formVlan_message_mask").style.color = "crimson";
    document.getElementById("formVlan_message_mask").innerHTML = message_mask;

    document.getElementById("formVlan_message_delay").style.visibility = "visible";
    document.getElementById("formVlan_message_delay").style.color = "crimson";
    document.getElementById("formVlan_message_delay").innerHTML = message_delay;


    return flag;
}

    var myFuncCalls = 0;

		function addRow(tableID) {

            myFuncCalls = myFuncCalls + 1;

			var table = document.getElementById(tableID);

			var rowCount = table.rows.length;
			var row = table.insertRow(rowCount);

			var colCount = table.rows[1].cells.length;

            var textCount = 0;

			for(var i=0; i<colCount; i++) {

				var newcell	= row.insertCell(i);

				newcell.innerHTML = table.rows[1].cells[i].innerHTML;

				//alert(newcell.childNodes);
				switch(newcell.childNodes[0].type) {
					case "text":
							newcell.childNodes[0].value = "";

							/*if(textCount == 0){

							    newcell.childNodes[0].name = "configs["+(rowCount-1)+"].nodeId";

							}else */if(textCount == 0){

							    newcell.childNodes[0].name = "configs["+(rowCount-1)+"].vlanName";

                            }else if(textCount == 1){

							    newcell.childNodes[0].name = "configs["+(rowCount-1)+"].ipToScan";

                            }else if(textCount == 2){

							    newcell.childNodes[0].name = "configs["+(rowCount-1)+"].mask";

                            }else if(textCount == 3){

							    newcell.childNodes[0].name = "configs["+(rowCount-1)+"].delay";

                            }
                            textCount = textCount + 1;

							break;
					case "checkbox":
							newcell.childNodes[0].checked = false;
							break;
					case "select-one":
							newcell.childNodes[0].selectedIndex = 0;
							break;

				}
			}
			//var elems = document.querySelectorAll("[id^='formVlan']");

            //elems[elems.length-1].id = "formVlan"+(rowCount-1)+"_message";

		}

		function deleteRow(tableID) {
			try {
			var table = document.getElementById(tableID);
			var rowCount = table.rows.length;

            console.log(rowCount);

			for(var i=0; i<rowCount; i++) {
				var row = table.rows[i];
				var chkbox = row.cells[0].childNodes[0];
				if(null != chkbox && true == chkbox.checked) {
					/*if(rowCount <= 1) {
						alert("Cannot delete all the rows.");
						break;
					}*/

					if(rowCount == 2) {

                        var elems = document.querySelectorAll("[name^='configs[']");

                        elems.forEach(function(element) {

                            element.value = "";
                        });

                        break;
                    }

					table.deleteRow(i);
					rowCount--;
					i--;
				}


			}
			}catch(e) {
				alert(e);
			}
		}

		<%-- Javascript code for toggling the visibility of scan_config objects when required --%>

        function toggle_scan(flag)
        {
            var elem = document.getElementById("scanC");
            var b1 = document.getElementById("button1");
            var b2 = document.getElementById("button2");
            var checkscan = document.getElementById("checkscan");
            var checkscan_label = document.getElementById("checkscan_label");

            var lenCheck = document.getElementById("span_id3").innerHTML.length;

            $('#'+b1.id).toggle();
            $('#'+b2.id).toggle();
            $('#'+checkscan.id).toggle();
            $('#'+checkscan_label.id).toggle();
            $('#createButton').toggle();

             if(!flag && lenCheck != 2) {

                if(elem.style.display.localeCompare("none") == 0){

                    $('#'+elem.id).css("display", "block");
                }

                if(lenCheck != 2){

                    document.getElementById("checkscan").checked = false;
                }

                document.getElementById('formName').style.background = "aliceblue";

                if(document.getElementById("span_id2").innerHTML.length == 0){

                    document.getElementById('formType').style.background = "aliceblue";
                    document.getElementById('formDescr').style.background = "aliceblue";
                    document.getElementById('formEmail').style.background = "aliceblue";
                    var labels = document.getElementsByTagName('label');
                            for (var i = 0; i < labels.length; i++) {
                                if (labels[i].htmlFor.includes('formAvailable')) {

                                     labels[i].style.background = "aliceblue";
                                }
                            }
                }
                document.getElementById("formVlan_message_vlan").innerHTML = "";

                document.getElementById("formVlan_message_ip").innerHTML = "";

                document.getElementById("formVlan_message_mask").innerHTML = "";

                document.getElementById("formVlan_message_delay").innerHTML = "";

             } else {

                 if(elem.style.display.localeCompare("block") == 0){

                     $('#'+elem.id).toggle();
                 }

                document.getElementById('formName').style.background = "";
                document.getElementById('formType').style.background = "";
                document.getElementById('formDescr').style.background = "";
                document.getElementById('formEmail').style.background = "";
                var labels = document.getElementsByTagName('label');
                            for (var i = 0; i < labels.length; i++) {
                                if (labels[i].htmlFor.includes('formAvailable')) {

                                     labels[i].style.background = "";
                                }
                            }
             }

        }

	</script>


<div class="jumbotron">
  <h1 id="title1">New Credentials</h1>
  <h1 id="title2" style="display:none">Edit Credentials for Node ${credentials.name}</h1>
  <a href="<core:url value='/curex/admin' />" style="float:left; padding-top:2%" >Previous Page</a>
</div>


<div class="container">


    <br>
  <div class="row">


<br>
<br>

<form:form method="POST" action="/curex/admin" modelAttribute="addForm" name="myForm" onsubmit="return validateForm(true)" >

<fieldset id="formField" style="border:0">

    <fieldset id="formField_small" style="border:0; margin-left:-0.6%">
        <div class="form-group">
                <label for="credentials.name">Node ID * <p style="font-size: 10px; margin-bottom: 0">(mandatory field)</p></label>
                <br>
                <form:input value="${credentials.name}" id="formName" path="credentials.name" cssClass="form-control" style="width:20%" name="name"/>
                <td> <label class="message" id="formName_message"></td>
            </div>
    </fieldset>

        <div class="form-group">
        <label for="credentials.type">Type</label>
        <br>
        <form:select path="credentials.type" id="formType" style="width:20%">
            <form:option value="${credentials.type}" label="${credentials.type}" />
            <form:options items="${user_types}" />
        </form:select>

        <%-- <form:input value="${credentials.type}" id="formType" path="credentials.type" cssClass="form-control"/> --%>

        </div>


        <div class="form-group">
        <label for="credentials.description">Description</label>
        <br>
        <textarea id="formDescr" name="credentials.description" style="width:25%">${credentials.description}</textarea>

        </div>


        <div class="form-group">

        <label for="credentials.email">E-mail * <p style="font-size: 10px;  margin-bottom: 0">(mandatory field)</p></label>
        <br>
        <form:input value="${credentials.email}" id="formEmail" path="credentials.email" cssClass="form-control" style="width:25%" />
        <form:errors path="credentials.email" cssStyle="color: red"/>
        <td> <label class="message" id="formEmail_message"></td>
        </div>


        <div class="form-group">
        <label for="credentials.availableEndpoint">Available Endpoints * <p style="font-size: 10px;  margin-bottom: 0">(mandatory field)</p></label>
        <br>
        <form:checkboxes id="formAvailable" path="credentials.endpoints" items="${endpoints}" element="div class='col-md-6 checkbox form-control' style='float:right'" />
        <td> <label class="message" id="formAvailable_message" style="padding-left:4%"></td>
        </div>

</fieldset>

        <br>
        <button type="button" id="button1" >OK</button>
        <button type="button" id="button2" style="display:none" >BACK</button>
        <input type="checkbox" id="checkscan" style="display:none" />
        <label id="checkscan_label" style="display:none">I will not require any scanning configuration (for now).</label>
        <br><br>


<div id="scanC" style="display:none">

    <INPUT type="button" value="Add Vlan" onclick="addRow('dataTable')" />
  	<INPUT type="button" value="Delete Vlan" onclick="deleteRow('dataTable')" />

  	<TABLE id="dataTable" border="1">

        <thead>

           <th style="text-align: center;">Select</th>
           <th style="text-align: center;">Vlan Name</th>
           <th style="text-align: center;">IP to scan</th>
           <th style="text-align: center;">Mask</th>

        </thead>
  		<TR>

  			<TD><INPUT type="checkbox" name="chk"/></TD>

  			<TD><INPUT type="text" value="${scans[0].vlanName}" name="configs[0].vlanName" /></TD>
  			<TD><INPUT type="text" value="${scans[0].ipToScan}" name="configs[0].ipToScan" /></TD>
  			<TD><INPUT type="text" value="${scans[0].mask}" name="configs[0].mask" /></TD>
  			<TD style="display:none"><INPUT type="text" value="${scans[0].delay}" name="configs[0].delay" style="display:none"/></TD>

  		</TR>


  		<core:forEach items="${scans}" var="scanconf" varStatus="loop">

            <core:if test="${loop.index > 0}">
                <TR>

                    <TD><INPUT type="checkbox" name="chk"/></TD>

                    <TD><INPUT type="text" value="${scanconf.vlanName}" name="configs[${loop.index}].vlanName" /></TD>
                    <TD><INPUT type="text" value="${scanconf.ipToScan}" name="configs[${loop.index}].ipToScan" /></TD>
                    <TD><INPUT type="text" value="${scanconf.mask}" name="configs[${loop.index}].mask" /></TD>
                    <TD style="display:none"><INPUT type="text" value="${scanconf.delay}" name="configs[${loop.index}].delay" style="display:none"/></TD>
                </TR>


            </core:if>

        </core:forEach>


  	</TABLE>

    <div><label class="message" id="formVlan_message_vlan"></div>
    <div><label class="message" id="formVlan_message_ip"></div>
    <div><label class="message" id="formVlan_message_mask"></div>

    <br>
    <label>Scanning delay (seconds):</label>
    <%-- <input type="text" value="" id="generalDelay" value="${scans[0].delay}" name="configs[0].delay" /> --%>
    <TD><INPUT id="generalDelay" type="text" value="${scans[0].delay}" name="configs[0].delay" /></TD>

    <div><label class="message" id="formVlan_message_delay"></div>

    <br><br>

</div>

<form:button class="btn btn-primary" id="createButton" style="display:none">CREATE</form:button>


</form:form>

<span id="span_id" style="display: none">${credentials.availableEndpoint}</span>
<span id="span_id2" style="display: none">${credentials.name}</span>
<span id="span_id3" style="display: none">${scans}</span>
<br>


<script src="webjars/bootstrap/4.1.3/js/bootstrap.min.js"></script>

<script language="javascript">
$(function() {

    if(document.getElementById("span_id3").innerHTML.length == 2){

        document.getElementById("checkscan").checked = true;

        var valType = document.getElementById("validationType");

        valType.attributes[2].value = "false";

    }

    var elems = document.querySelectorAll("[id^='formAvailable']");

    var already = document.getElementById("span_id").innerHTML;

    elems.forEach(function(element) {

        if(already.includes(document.getElementById(element.id).value)){

            $('#'+element.id).prop('checked', true);
        }

    });

    if(document.getElementById("span_id2").innerHTML.length > 0){

        document.getElementById("button1").click();
        document.getElementById("button2").style.display="none";
        document.getElementById("title1").style.display="none";
        document.getElementById("title2").style.display="";
    }




});

var form = document.getElementById('formField'),//forms[0], // form element to be "readonly"
    form_small = document.getElementById('formField_small'),
    btn1 = document.querySelectorAll('button')[0],
    btn2 = document.querySelectorAll('button')[1],
    checkscan = document.getElementById('checkscan'),
    checkscan_label = document.getElementById('checkscan_label')


btn1.addEventListener('click', function(){
    lockFormByCSS(true);
    });

btn2.addEventListener('click', function(){
    lockFormByCSS(false);
    });

checkscan.addEventListener('click', function(){
    changeValidation();
    });

function changeValidation(){

     $('#scanC').toggle();

     var valType = document.getElementById("validationType");

     if(valType.attributes[2].value == "true"){

        valType.attributes[2].value = "false";
     }else{

        valType.attributes[2].value = "true";
     }
}

function lockFormByCSS(flag){

  var res = validateForm(false);
  console.log(res);
  if(res){

    if(flag){

        toggle_scan(false); // OK
    }else{

        toggle_scan(true); // BACK
    }

    btn2.classList.toggle('on');
    if(document.getElementById("span_id2").innerHTML.length > 0){
        form_small.classList.toggle('lock');
    }else{
        form.classList.toggle('lock');
    }


  }
}


</script>

<script src="http://code.jquery.com/jquery-latest.js">
</script>
<script>
	$(document).ready(function() {

	    $.get("http://138.4.130.51:8080/vlans?token=e77c08ff686581963e6f4bfea4ee3ad9", function(datos){
	        console.log(datos);
	    });

		$('#formName').blur(function(event) {
			var nombreVar = $('#formName').val();
            console.log(nombreVar);


		});
	});
</script>

</body>
</html>
