<!DOCTYPE html>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Visualization Service</title>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/fetch/2.0.3/fetch.min.js"></script>
    <script src="https://d3js.org/d3.v4.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/flatpickr/dist/flatpickr.min.css">
    <script src="https://cdn.jsdelivr.net/npm/flatpickr"></script>
    <%-- <link rel="stylesheet" href="css/visual_style.css" /> --%>
    <link href="<c:url value="/css/visual_style.css" />" rel="stylesheet">

    <link href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" rel="stylesheet">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>

</head>

<body>
<div class="jumbotron">
  <h1 id="signHeader1">Visualization Service</h1>


      <% Object logged = session.getAttribute("loginStatus");
        if ("OK".equals(logged)) { %>
      <a href="<c:url value='/curex/admin' />" style="float:left; padding-top:2%; " >Previous Page</a>
      <% }
        if ("FAILED".equals(logged)) { %>
      <% } %>

</div>

    <div class="p-2 offset-lg-5 offset-sm-4 offset-5">
        <form class="row" onsubmit="return false">
            <label class="col-12" for="time_selector">Pick a date and time:</label>
            <input class="form-control col-xl-3 col-md-4 col-sm-5 col-7" id="time_selector"/>
            <button type="button" class="btn btn-info mr-3" id="submit">Submit</button>
            <small class="p-2 alert alert-danger m-0 d-none" id="error_message">* Choose a date and time to submit</small>
        </form>
    </div>

    <div class="row align-content-center">
        <div class="col-xl-6 col-lg-12 offset-md-1 offset-lg-2 offset-xl-0" id="svg-wrapper">
            <svg id="d3"></svg>
        </div>

        <div class="col-xl-6 align-self-xl-center col-lg-l2 pt-2 pb-5 pl-5 pr-5" id="overlapped">
            <div id="table-wrapper" class="tableFixHead">
                <div><strong>Current snapshot: </strong><span id="current_snapshot"></span></div>
                <div><strong>VLAN: </strong><span id="vlan_name"></span></div>
                <div><strong>Host Name: </strong><span id="host_name"></span></div>
                <div><strong>Operating System: </strong><span id="operating_system"></span></div>
                <table class="table table-custom">
                    <thead>
                    <tr>
                        <th>Port</th>
                        <th>Service</th>
                        <th>Status</th>
                    </tr>
                    </thead>

                    <tbody id="tbody">
                    </tbody>
                </table>
            </div>
        </div>
    </div>
<div style="display: none" id="circle-data" data-circle=""></div>

</body>

<span id="span_id1" style="display: none">${baseURL}</span>
<span id="span_id2" style="display: none">${visualToken}</span>

<script type="text/javascript" src="<c:url value="/js/visual.js" />" ></script>

</html>